Attribute VB_Name = "modINIHandling"
Option Explicit
'API Declares
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer

'This function gets the setting
Function GetINISetting(ByRef strSectionHeader As String, ByRef strVariableName As String, Optional ByRef strDefault As String = "") As String
    Dim strReturn As String
    Dim intLen As Integer
    strReturn = String(255, Chr(32))
    intLen = GetPrivateProfileString(strSectionHeader, strVariableName, strDefault, strReturn, Len(strReturn), App.Path & "\Settings.ini")
    GetINISetting = Left(strReturn, intLen)
End Function

'this function saves a setting
Function WriteINISetting(ByRef strSectionHeader As String, ByRef strVariableName As String, ByRef strValue As String) As Integer
    WriteINISetting = WritePrivateProfileString(strSectionHeader, strVariableName, strValue, App.Path & "\Settings.ini")
End Function

'this one deletes a setting
Function DelINISetting(ByRef strSection As String, ByRef strSetting As String) As Integer
    DelINISetting = WritePrivateProfileString(strSection, strSetting, &O0, App.Path & "\Settings.ini")
End Function

'and this one delets an entire section
Function DelINISection(ByRef strSection As String) As Integer
    DelINISection = WritePrivateProfileString(strSection, 0&, 0&, App.Path & "\Settings.ini")
End Function

'this sets a setting to blank
Function ClearINISetting(ByRef strSection As String, ByRef strSetting As String) As Integer
    ClearINISetting = WritePrivateProfileString(strSection, strSetting, "", App.Path & "\Settings.ini")
End Function

'checks if a file exists
Public Function FileExist(dPath As String) As Boolean
    On Error GoTo errorH

    If FileLen(dPath) > -1 Then
        FileExist = True
    End If

    Exit Function

errorH:
    FileExist = False

End Function

'create all folders for a given file, if the folders are not there already
Public Sub MakeDirs(strPath As String)
    Dim strWorkingPath As String
    strWorkingPath = strPath
    strWorkingPath = Left(strWorkingPath, InStrRev(strWorkingPath, "\") - 1)
    If Not Dir(strWorkingPath, vbDirectory) = "" Then
        Exit Sub
    Else
        MakeDirs (strWorkingPath)
        MkDir (strWorkingPath)
    End If
End Sub
